package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(IISLSingleSpaceMapMethods_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public interface IISLSingleSpaceMapMethods  extends IISLSingleSpaceMethods, IISLSingleSpaceReadOnlyMapMethods {
	
	
	/*** PROTECTED REGION ID(IISLSingleSpaceMapMethods_userCode) ENABLED START ***/
	public String getTupleName(ISLDimType dimType);
	public <T extends IISLSingleSpaceMapMethods> T setTupleName(ISLDimType dimType, String s);

	public default <T extends IISLSingleSpaceMapMethods> T renameInputs(List<String> names) {
		return renameDims(names, ISLDimType.isl_dim_in);
	}
	
	public default <T extends IISLSingleSpaceMapMethods> T renameOutputs(List<String> names) {
		return renameDims(names, ISLDimType.isl_dim_out);
	}
	
	public default <T extends IISLSingleSpaceMapMethods> T addInputs(List<String> names) {
		return addDims(names, ISLDimType.isl_dim_in);
	}

	public default <T extends IISLSingleSpaceMapMethods> T addOutputs(List<String> names) {
		return addDims(names, ISLDimType.isl_dim_out);
	}

	public default <T extends IISLSingleSpaceMapMethods> T moveParamsToInputs() {
		return moveAllDims(ISLDimType.isl_dim_in, ISLDimType.isl_dim_param);
	}
	
	public default <T extends IISLSingleSpaceMapMethods> T moveInputsToParams() {
		return moveAllDims(ISLDimType.isl_dim_param, ISLDimType.isl_dim_in);
	}

	public default <T extends IISLSingleSpaceMapMethods> T moveParamsToOutputs() {
		return moveAllDims(ISLDimType.isl_dim_out, ISLDimType.isl_dim_param);
	}
	
	public default <T extends IISLSingleSpaceMapMethods> T moveOutputsToParams() {
		return moveAllDims(ISLDimType.isl_dim_param, ISLDimType.isl_dim_out);
	}
		
	public default String getInputTupleName() {
		return getTupleName(ISLDimType.isl_dim_in);
	}

	public default String getOutputTupleName() {
		return getTupleName(ISLDimType.isl_dim_out);
	}

	public default <T extends IISLSingleSpaceMapMethods> T setInputTupleName(String s) {
		return setTupleName(ISLDimType.isl_dim_in, s);
	}

	public default <T extends IISLSingleSpaceMapMethods> T setOutputTupleName(String s) {
		return setTupleName(ISLDimType.isl_dim_out, s);
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	
}
